<?php
namespace Teknisa\Model\Services\Repositories;


class FctApropagendamento extends \Doctrine\ORM\EntityRepository {

    public function findApropAgendamentoByIdAndDtapropriacao($nrApropAgendamento, $dtapropriacao)
    {
        $query = <<<SQL
            SELECT * 
              FROM FCT_APROPAGENDAMENTO AG
             WHERE AG.NRAPROPAGENDAMENTO = :NRAPROPAGENDAMENTO
               AND TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') = :DTAPROPRIACAO
SQL;

        $params = array(
            'NRAPROPAGENDAMENTO' => $nrApropAgendamento,
            'DTAPROPRIACAO' => $dtapropriacao
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }

    public function findApropAgendamentoByServiceIdAndDtapropriacao($nrApropAgendamento, $dtapropriacao)
    {
        $query = <<<SQL
            SELECT * 
              FROM FCT_APROPAGENDAMENTO AG
             WHERE AG.NRRECURSOSAGENDCONT = :NRRECURSOSAGENDCONT
               AND TO_CHAR(AG.DTAPROPRIACAO, 'DD/MM/YYYY') = :DTAPROPRIACAO
SQL;

        $params = array(
            'NRRECURSOSAGENDCONT' => $nrApropAgendamento,
            'DTAPROPRIACAO' => $dtapropriacao
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);

    }


}